## qgnomeplatform 0.9.0

=== CMakeLists.txt ===
project(QGnomePlatform)

cmake_minimum_required(VERSION 3.0)

set(QGNOMEPLATFORM_VERSION "0.9.0")

option(USE_QT6 "Use Qt6 instead of Qt5" OFF)

if (USE_QT6)
    set(QT_MIN_VERSION "6.2.0")
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(LIBQGNOMEPLATFORM_SUFFIX "6")
else()
    set(QT_MIN_VERSION "5.15.2")
    set(CMAKE_CXX_STANDARD 14)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(LIBQGNOMEPLATFORM_SUFFIX "")
endif()

set(CMAKE_AUTOMOC ON)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" ${CMAKE_MODULE_PATH})

include(GNUInstallDirs)
include(FeatureSummary)

if (USE_QT6)
    find_package(QT NAMES Qt6 COMPONENTS Core DBus Gui Widgets REQUIRED)
else()
    find_package(QT NAMES Qt5 COMPONENTS Core DBus Gui Widgets REQUIRED)
endif()

find_package(Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Core
    DBus
    Gui
    Widgets
)

find_package(Qt${QT_VERSION_MAJOR}Gui ${QT_MIN_VERSION} CONFIG REQUIRED Private)

if (NOT USE_QT6)
    find_package(Qt${QT_VERSION_MAJOR}ThemeSupport REQUIRED)
endif()

find_package(GSettingSchemas REQUIRED)
if (USE_QT6)
    find_package(AdwaitaQt6 "1.4.2" REQUIRED)
else()
    find_package(AdwaitaQt "1.4.2" REQUIRED)
endif()

find_package(PkgConfig REQUIRED)
pkg_check_modules(GTK+3 REQUIRED IMPORTED_TARGET gtk+-3.0)

# NOTE: there is no reason to disable any of the following options, but
# it is useful when building Flatpak extensions
if (DISABLE_DECORATION_SUPPORT)
    message(STATUS "Disabling Qt Wayland decoration support")
else()
    find_package(Qt${QT_VERSION_MAJOR}WaylandClient ${QT_MIN_VERSION} CONFIG REQUIRED)
    set_package_properties(Qt${QT_VERSION_MAJOR}WaylandClient PROPERTIES
        DESCRIPTION "Qt Wayland decoration support"
        PURPOSE "Required for QGnomePlatform decoration plugin"
        TYPE REQUIRED
    )
    # NOTE: I don't know how to do this only in case of qt_config(xkbcommon).
    # We would miss an include in QWaylandDisplay header file.
    if (NOT USE_QT6)
        find_package(Qt${QT_VERSION_MAJOR}XkbCommonSupport ${QT_MIN_VERSION})
    endif()

    if (DECORATION_SHADOWS_SUPPORT OR USE_QT6)
        message(STATUS "Enabling Qt Wayland decoration shadows support")
        message(STATUS "NOTE: This support requires changes in Qt Wayland from Qt 6.2")
        add_definitions(-DDECORATION_SHADOWS_SUPPORT)
    endif()
endif()

if (DISABLE_THEME_SUPPORT)
    message(STATUS "Disabling platform theme support")
endif()

if (NOT QT_PLUGINS_DIR)
    if (NOT USE_QT6)
        get_target_property(REAL_QMAKE_EXECUTABLE ${Qt5Core_QMAKE_EXECUTABLE}
                            IMPORTED_LOCATION)
        execute_process(COMMAND "${REAL_QMAKE_EXECUTABLE}" -query QT_INSTALL_PLUGINS
                        OUTPUT_VARIABLE QT_PLUGINS_DIR
                        ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    else()
        set(QT_PLUGINS_DIR ${QT6_INSTALL_PLUGINS})
    endif()
endif()

add_subdirectory(src)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/common/CMakeLists.txt ===

set(common_SRCS
    gnomesettings.cpp
    gsettingshintprovider.cpp
    hintprovider.cpp
    portalhintprovider.cpp
    utils.cpp
)

add_library(qgnomeplatform${LIBQGNOMEPLATFORM_SUFFIX} SHARED ${common_SRCS})
target_link_libraries(qgnomeplatform${LIBQGNOMEPLATFORM_SUFFIX}
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    Qt${QT_VERSION_MAJOR}::Widgets
    ${ADWAITAQT_LIBRARIES}
    PkgConfig::GTK+3
)

install(TARGETS "qgnomeplatform${LIBQGNOMEPLATFORM_SUFFIX}" RUNTIME DESTINATION bin LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/theme/CMakeLists.txt ===

include_directories(
    ${CMAKE_SOURCE_DIR}/src/common
)

set(theme_SRCS
    platformplugin.cpp
    qgnomeplatformtheme.cpp
    qgtk3dialoghelpers.cpp
    qxdgdesktopportalfiledialog.cpp
)

add_library(qgnomeplatformtheme MODULE ${theme_SRCS})
target_link_libraries(qgnomeplatformtheme
    qgnomeplatform${LIBQGNOMEPLATFORM_SUFFIX}
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    ${ADWAITAQT_LIBRARIES}
    PkgConfig::GTK+3
)

if (NOT USE_QT6)
    target_link_libraries(qgnomeplatformtheme Qt5::ThemeSupportPrivate)
endif()

install(TARGETS qgnomeplatformtheme DESTINATION ${QT_PLUGINS_DIR}/platformthemes)

## qgnomeplatform 0.8.4

=== debian/changelog ===
qgnomeplatform (0.8.4-1) unstable; urgency=low

  * Initial release. (Closes: #1013369)

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Thu, 29 Sep 2022 13:04:41 -0700

=== debian/control ===
Source: qgnomeplatform
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Matthias Geiger <matthias.geiger1024@tutanota.de>
Build-Depends: cmake (>= 3.0),
               debhelper-compat (= 13),
               gsettings-desktop-schemas-dev,
               libadwaitaqt-dev (>= 1.4.1~),
               libglib2.0-dev,
               libgtk-3-dev,
               qtbase5-private-dev (>= 5.15.2~),
               qtwayland5-private-dev (>= 5.15.2~),
Standards-Version: 4.6.1
Homepage: https://github.com/FedoraQt/QGnomePlatform
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qgnomeplatform.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qgnomeplatform
Rules-Requires-Root: no

Package: qgnomeplatform-qt5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 extra widget styles - GNOME Platform theme
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the GNOME style and platform theme. Export
 QT_QPA_PLATFORMTHEME=gnome to enable it for all Qt applications.

## qgnomeplatform 0.9.0

=== debian/changelog ===
qgnomeplatform (0.9.0-1) unstable; urgency=medium

  * Team upload.

  [ Matthias Geiger ]
  * New upstream release
  * Fixed issues in d/copyright

  [ Aurélien COUDERC ]
  * Change maintainer to the Debian KDE Extras Team.
  * Bump Standards-Version to 4.6.2, no change required.
  * Update build-deps and deps with the info from cmake.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 26 Dec 2022 22:46:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,19 @@
 Source: qgnomeplatform
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
 Uploaders: Matthias Geiger <matthias.geiger1024@tutanota.de>
 Build-Depends: cmake (>= 3.0),
                debhelper-compat (= 13),
+               gsettings-desktop-schemas,
                gsettings-desktop-schemas-dev,
-               libadwaitaqt-dev (>= 1.4.1~),
+               libadwaitaqt-dev (>= 1.4.2~),
                libglib2.0-dev,
                libgtk-3-dev,
+               pkg-config,
                qtbase5-private-dev (>= 5.15.2~),
                qtwayland5-private-dev (>= 5.15.2~),
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/FedoraQt/QGnomePlatform
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qgnomeplatform.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qgnomeplatform

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT := qt5

%:
	dh $@

## qgnomeplatform 0.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 cmake_minimum_required(VERSION 3.0)
 
-set(QGNOMEPLATFORM_VERSION "0.9.0")
+set(QGNOMEPLATFORM_VERSION "0.9.1")
 
 option(USE_QT6 "Use Qt6 instead of Qt5" OFF)
 
@@ -36,6 +36,7 @@
     DBus
     Gui
     Widgets
+    QuickControls2
 )
 
 find_package(Qt${QT_VERSION_MAJOR}Gui ${QT_MIN_VERSION} CONFIG REQUIRED Private)
@@ -50,6 +51,17 @@
 else()
     find_package(AdwaitaQt "1.4.2" REQUIRED)
 endif()
+
+
+if (NOT USE_QT6)
+    find_package(KF5QQC2DesktopStyle)
+    set_package_properties(KF5QQC2DesktopStyle PROPERTIES
+        DESCRIPTION "Styling for QtQuick Controls 2 applications"
+        TYPE RUNTIME)
+else()
+    # TODO, the desktop style for Qt6 is not yet released
+endif()
+
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(GTK+3 REQUIRED IMPORTED_TARGET gtk+-3.0)

=== debian/changelog ===
qgnomeplatform (0.9.1-1build1) mantic; urgency=medium

  * No-change rebuild against Qt 5.15.10.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 20 Jun 2023 23:53:21 +0300

qgnomeplatform (0.9.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1032838)
  * Add new B-Ds in d/control

 -- Matthias Geiger <matthias.geiger1024@tutanota.de>  Mon, 12 Jun 2023 23:52:07 +0200

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,8 @@
                pkg-config,
                qtbase5-private-dev (>= 5.15.2~),
                qtwayland5-private-dev (>= 5.15.2~),
+               qtquickcontrols2-5-dev,
+               qtdeclarative5-dev (>= 5.15.8~),
 Standards-Version: 4.6.2
 Homepage: https://github.com/FedoraQt/QGnomePlatform
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qgnomeplatform.git

## qgnomeplatform 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 cmake_minimum_required(VERSION 3.0)
 
-set(QGNOMEPLATFORM_VERSION "0.9.1")
+set(QGNOMEPLATFORM_VERSION "0.9.2")
 
 option(USE_QT6 "Use Qt6 instead of Qt5" OFF)

=== src/CMakeLists.txt ===
add_subdirectory(color-schemes)
add_subdirectory(common)

if (NOT DISABLE_DECORATION_SUPPORT)
    add_subdirectory(decoration)
endif()

if (NOT DISABLE_THEME_SUPPORT)
    add_subdirectory(theme)
endif()

=== src/color-schemes/CMakeLists.txt ===
install(FILES Adwaita.colors DESTINATION ${CMAKE_INSTALL_DATADIR}/color-schemes/)
install(FILES AdwaitaDark.colors DESTINATION ${CMAKE_INSTALL_DATADIR}/color-schemes/)
install(FILES AdwaitaHighcontrast.colors DESTINATION ${CMAKE_INSTALL_DATADIR}/color-schemes/)
install(FILES AdwaitaHighcontrastInverse.colors DESTINATION ${CMAKE_INSTALL_DATADIR}/color-schemes/)

=== src/decoration/CMakeLists.txt ===

include_directories(
    ${CMAKE_SOURCE_DIR}/src/common
)

set(decoration_SRCS
    decorationplugin.cpp
    qgnomeplatformdecoration.cpp
)

add_library(qgnomeplatformdecoration MODULE ${decoration_SRCS})
target_link_libraries(qgnomeplatformdecoration
    qgnomeplatform${LIBQGNOMEPLATFORM_SUFFIX}
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
    ${ADWAITAQT_LIBRARIES}
    PkgConfig::GTK+3
)

if (NOT USE_QT6)
    if (${Qt5XkbCommonSupport_FOUND})
    target_link_libraries(qgnomeplatformdecoration
        Qt${QT_VERSION_MAJOR}::XkbCommonSupportPrivate
    )
    endif()
endif()

install(TARGETS qgnomeplatformdecoration DESTINATION ${QT_PLUGINS_DIR}/wayland-decoration-client)

=== src/theme/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
     Qt${QT_VERSION_MAJOR}::DBus
     Qt${QT_VERSION_MAJOR}::Gui
     Qt${QT_VERSION_MAJOR}::GuiPrivate
+    Qt${QT_VERSION_MAJOR}::QuickControls2
     ${ADWAITAQT_LIBRARIES}
     PkgConfig::GTK+3
 )

=== debian/changelog ===
qgnomeplatform (0.9.2-5) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Fix build failure with CMake 4 (Closes: #1113440).
  * Bump Standards-Version to 4.7.2 (no changes needed).

 -- Patrick Franz <deltaone@debian.org>  Wed, 17 Sep 2025 18:45:55 +0200

qgnomeplatform (0.9.2-4) unstable; urgency=medium

  * Team upload.
  * Add a patch to fix FTBFS with qtbase 5.15.13+dfsg-4 (Closes:
    #1077421).

 -- Patrick Franz <deltaone@debian.org>  Fri, 13 Sep 2024 21:52:31 +0200

qgnomeplatform (0.9.2-3) unstable; urgency=medium

  * Upload to unstable 
  * Fix typo in d/control

 -- Matthias Geiger <werdahias@riseup.net>  Thu, 27 Jun 2024 21:50:46 +0200

qgnomeplatform (0.9.2-2) experimental; urgency=medium

  * Build QT6 plugin, too (Closes: #1032840)
    - Drop QT_SELECT from d/rules
    - Build-depend on libkf5qqc2desktopstyle-dev for QT5 plugin
    - Build-depend on qt6-base-dev, qt6-declarative-dev, libadwaitaqt6-dev,
      qt6-wayland-dev, qt6-base-private-dev, qt6-wayland-private-dev
    - Update lintian overrides for new binary package 
  * d/control: Switch from pkg-config to pkgconf
  * Bump Standards-Version to 4.7.0; no changes needed

 -- Matthias Geiger <werdahias@riseup.net>  Thu, 27 Jun 2024 16:32:29 +0200

qgnomeplatform (0.9.2-1) unstable; urgency=medium

  * New upstream release.
  * Updated my mail address in d/control

 -- Matthias Geiger <werdahias@riseup.net>  Wed, 13 Sep 2023 19:28:56 +0200

=== debian/control ===
Source: qgnomeplatform
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Matthias Geiger <werdahias@riseup.net>
Build-Depends: cmake (>= 3.0),
               debhelper-compat (= 13),
               gsettings-desktop-schemas,
               gsettings-desktop-schemas-dev,
               libadwaitaqt-dev (>= 1.4.2~),
               libglib2.0-dev,
               libgtk-3-dev,
               libkf5qqc2desktopstyle-dev,
               pkgconf,
               qtbase5-private-dev (>= 5.15.2~),
               qtwayland5-private-dev (>= 5.15.2~),
               qtquickcontrols2-5-dev,
               qtdeclarative5-dev (>= 5.15.8~),
               qt6-base-dev (>= 6.2.0~),
               qt6-base-private-dev (>= 6.2.0~),
               qt6-declarative-dev (>= 6.2.0),
               libadwaitaqt6-dev (>= 1.4.2~),
               qt6-wayland-dev (>= 6.2.0~),
               qt6-wayland-private-dev (>= 6.2.0~),
Standards-Version: 4.7.2
Homepage: https://github.com/FedoraQt/QGnomePlatform
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qgnomeplatform.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qgnomeplatform
Rules-Requires-Root: no

Package: qgnomeplatform-qt5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 5 extra widget styles - GNOME Platform theme
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the GNOME style and platform theme for QT5. Export
 QT_QPA_PLATFORMTHEME=gnome to enable it for all Qt5 applications.

Package: qgnomeplatform-qt6
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt 6 extra widget styles - GNOME Platform theme
 Qt is a cross-platform C++ application framework. Qt's primary feature
 is its rich set of widgets that provide standard GUI functionality.
 .
 This package contains the GNOME style and platform theme for QT6. Export
 QT_QPA_PLATFORMTHEME=gnome to enable it for all Qt6 applications.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@



override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5
	dh_auto_configure --builddir=qt6-build -- -DUSE_QT6=true -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddir=qt6-build

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddir=qt6-build

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/QGnomePlatform-$1\.tar\.gz/ \
  https://github.com/FedoraQt/QGnomePlatform/tags .*/v?(\d\S+)\.tar\.gz
